def batch_norm(input: Tensor,
    running_mean: Optional[Tensor],
    running_var: Optional[Tensor],
    weight: Optional[Tensor]=None,
    bias: Optional[Tensor]=None,
    training: bool=False,
    momentum: float=0.10000000000000001,
    eps: float=1.0000000000000001e-05) -> Tensor:
  _0 = __torch__.torch.nn.functional._verify_batch_size
  if training:
    _1 = _0(torch.size(input), )
  else:
    pass
  _2 = torch.batch_norm(input, weight, bias, running_mean, running_var, training, momentum, eps, True)
  return _2
def relu(input: Tensor,
    inplace: bool=False) -> Tensor:
  if inplace:
    result = torch.relu_(input)
  else:
    result = torch.relu(input)
  return result
def _max_pool2d(input: Tensor,
    kernel_size: List[int],
    stride: Optional[List[int]]=None,
    padding: List[int]=[0, 0],
    dilation: List[int]=[1, 1],
    ceil_mode: bool=False,
    return_indices: bool=False) -> Tensor:
  if torch.__is__(stride, None):
    stride0 = annotate(List[int], [])
  else:
    stride0 = unchecked_cast(List[int], stride)
  _3 = torch.max_pool2d(input, kernel_size, stride0, padding, dilation, ceil_mode)
  return _3
def adaptive_avg_pool2d(input: Tensor,
    output_size: List[int]) -> Tensor:
  _4 = torch.gt(torch.len(torch.size(input)), torch.len(output_size))
  if _4:
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _5 = torch.adaptive_avg_pool2d(input, output_size)
  return _5
def dropout(input: Tensor,
    p: float=0.5,
    training: bool=True,
    inplace: bool=False) -> Tensor:
  _6 = "dropout probability has to be between 0 and 1, but got {}"
  if torch.lt(p, 0.):
    _7 = True
  else:
    _7 = torch.gt(p, 1.)
  if _7:
    ops.prim.RaiseException(torch.format(_6, p), "builtins.ValueError")
  else:
    pass
  if inplace:
    _8 = torch.dropout_(input, p, training)
  else:
    _8 = torch.dropout(input, p, training)
  return _8
def softmax(input: Tensor,
    dim: Optional[int]=None,
    _stacklevel: int=3,
    dtype: Optional[int]=None) -> Tensor:
  _9 = __torch__.torch.nn.functional._get_softmax_dim
  if torch.__is__(dim, None):
    dim1 = _9("softmax", torch.dim(input), _stacklevel, )
    dim0 = dim1
  else:
    dim0 = unchecked_cast(int, dim)
  if torch.__is__(dtype, None):
    ret = torch.softmax(input, dim0)
  else:
    dtype0 = unchecked_cast(int, dtype)
    ret = torch.softmax(input, dim0, dtype0)
  return ret
def _verify_batch_size(size: List[int]) -> NoneType:
  _10 = "Expected more than 1 value per channel when training, got input size {}"
  size_prods = size[0]
  size_prods0 = size_prods
  for i in range(torch.sub(torch.len(size), 2)):
    size_prods1 = torch.mul(size_prods0, size[torch.add(i, 2)])
    size_prods0 = size_prods1
  if torch.eq(size_prods0, 1):
    ops.prim.RaiseException(torch.format(_10, size), "builtins.ValueError")
  else:
    pass
  return None
def _get_softmax_dim(name: str,
    ndim: int,
    stacklevel: int) -> int:
  _11 = "Implicit dimension choice for {} has been deprecated. Change the call to include dim=X as an argument."
  torch.warn(torch.format(_11, name), stacklevel)
  if torch.eq(ndim, 0):
    _12 = True
  else:
    _12 = torch.eq(ndim, 1)
  if _12:
    _13 = True
  else:
    _13 = torch.eq(ndim, 3)
  if _13:
    ret = 0
  else:
    ret = 1
  return ret
